/* primitive.h
 * Copyright (C) 2004 Djukic Marko, Pernus Klemen, Zagar Miha
 * For conditions of distribution and use, see the copyright notice in main.cpp
 */
#ifndef _PRIMITIVE_H_
#define _PRIMITIVE_H_

#include "point.h"
#include "fx.h"


//razred primitive vsebuje skupne lastnosti objekotm in omejitvam
class Primitive {
protected: 
	//pove ali je objekt izbran ali ne
	unsigned char selected;
	//vrne zaporedno steivilko kdaj je bil dodan (razlicna za vsak objekt)
	unsigned int age; 
	//najblizja tocka na objektu ki jo postavi get_distance() funkcija
	Point *closest_point;
public:
	static unsigned int current_age;
	//konstruktorcek
	Primitive();
	//postavi ali je objekt izbran ali ne
	void set_selected(unsigned char state);
	//vrne ali je objekt izbran ali ne
	unsigned char is_selected();
	//vrne starost objekta
	unsigned int get_age();

	void set_youngest();
	//vrene razliko v pixlih med tockama t1 in t2
	static unsigned int diff(Point *t1, Point *t2);

	//vrne najblizjo tocko ... postavlja se z klicom get_distance funkcije
	Point *get_closest_point();

	//se narise na hdc
	virtual void draw(FXDCWindow *hdc) {};
	//vrne razdaljo tocke od objekta in postavi closest_point
	virtual unsigned int get_distance(Point *tocka) {return 0;};
	//vrne 1 ce tocka na objektu ali 0 ce tocka ni na objektu
	virtual unsigned char on_object(Point *tocka) {return 0;};
};

class Object; //vnaprejsnja deklaracija
class Constraint; //vnaprejsnja deklaracija


#endif //_PRIMITIVE_H_