/* recognizer.h
 * Copyright (C) 2004 Djukic Marko, Pernus Klemen, Zagar Miha
 * For conditions of distribution and use, see the copyright notice in main.cpp
 */
#ifndef _RECOGNIZER_H_
#define _RECOGNIZER_H_

#include <list>
using namespace std;

#include "trace.h"
#include "llist.h"
#include "objects.h"

#include "ai.h"

class AI;

class Recognizer {
private:
	//nasa umetna inteligenca
	AI *ai;
	//lista prepoznanih objektov
	LList<Object> *recognized_objects;
	//tocke po casu zlozi v list spodaj
	void get_points(Trace *user_data);
	//ima zapisane tocke po casu
	list <Point*> points_list;
	//pove, ali je crta dovolj ravna
	Line* evaluate(float max_average_diff, Trace *user_data);
	//sprozi iskanje lomljenih crt ali likov
	void find_complex_lines();
	//najde zacetna oglisc za find_complex_lines
	list <Point*> find_start_vertexes();
	//najde v points_list ustreznico tocki v vl
	list <Point*>::iterator get_point_pos(list <Point*>::iterator vl_iter, list <Point*>::iterator iter_start);
	//pogleda v vl ter pove, ce rabimo novo oglisce
	unsigned char perform_fitting(list <Point*> *vl, list <Point*>::iterator vl_iter,list <Point*>::iterator iter_start, list <Point*>::iterator iter_end, float max_aver_dist, unsigned char mode);
public:
	//postavitev prepoznavalca z ai-jem 
	Recognizer(AI *_ai); 
	//solve kot argument sprejme sled tistega kar je uporanik narisal
	//in vrne 1 ce je nasel resitev ali 0 ce je ni
	unsigned char recognize(Trace *user_data);
	//vrne objekt ki ga je prepoznal, oz NULL ce ne prepozna nic
	//ali ce je vrnil ze vse objekte
	Object* get_object();
	//razdalja tocke do premice(implicitna oblika)
	float dist_point_line(float a, float b, float c, Point *point);
	//razdalja tocka tocka
	float dist_point_point(Point *point_1, Point *point_2);
	
	void add_line_to_database(Trace *user_data);

	float length_diff(Line *line, Trace *user_data);
};
#endif //_RECOGNIZER_H_