/* tuner.h
 * Copyright (C) 2004 Djukic Marko, Pernus Klemen, Zagar Miha
 * For conditions of distribution and use, see the copyright notice in main.cpp
 */
#ifndef _TUNER_H_
#define _TUNER_H_

#include "fx.h"
#include "trace.h"
#include "recognizer.h"
#include "objects.h"
#include "ai.h" //ai ... modul kjer bom spreminjal parametre

class TunerWindow : public FXDialogBox {
	FXDECLARE(TunerWindow)
private:
	//ai class za spreminajnje nastavite
	AI *ai;
	Recognizer *recognizer;

	TunerWindow(){}
	TunerWindow(const TunerWindow&);

	int mouse_down;

	//stik rob<->rob
	FXCanvas *connection_1_type_canvas;
	FXDataTarget connection_1_type_data_target;	
	//stik rob<->crta
	FXCanvas *connection_2_type_canvas;
	FXDataTarget connection_2_type_data_target;	

	//kdaj je zadeva parallelna
	FXCanvas *parallel_1_type_canvas;
	FXDataTarget parallel_1_type_data_target;
	//kdaj je zadeva poravnava (nulti diff)
	FXCanvas *parallel_3_type_canvas;
	FXDataTarget parallel_3_type_data_target;


	//kot pr katerem se se poravna na navlisno ali vodoravno
	FXCanvas *angle_1_type_canvas;
	FXDataTarget angle_1_type_data_target;	
	//kot pri katerem se dve crti zlijeta v eno samo
	FXCanvas *angle_2_type_canvas;
	FXDataTarget angle_2_type_data_target;	


	//nastavaitve za prepoznavalca crt ...
	FXCanvas *complex_line_canvas;
	Trace *complex_line_trace;
	FXDataTarget complex_line_1_eps_data_target;	
	FXDataTarget complex_line_2_eps_data_target;	
	FXint complex_line_1_eps_value;
	FXint complex_line_2_eps_value;



public:
	long connection_1_type(FXObject*,FXSelector,void*);
	long angle_1_type(FXObject*,FXSelector,void*);
	long angle_2_type(FXObject*,FXSelector,void*);

	long complex_line_canvas_paint(FXObject*,FXSelector,void*);	
	long complex_line_canvas_mouse_down(FXObject*,FXSelector,void*);
	long complex_line_canvas_mouse_up(FXObject*,FXSelector,void*);
	long complex_line_canvas_mouse_move(FXObject*,FXSelector,void*);
	
	TunerWindow(FXWindow *owner, AI *ai, Recognizer *rec);
	virtual ~TunerWindow();

	enum {
		ID_CONNECTION_1_TYPE = FXDialogBox::ID_LAST,
		ID_CONNECTION_1_TYPE_PAINT,
		ID_CONNECTION_2_TYPE,
		ID_CONNECTION_2_TYPE_PAINT,
		ID_PARALLEL_1_TYPE,
		ID_PARALLEL_1_TYPE_PAINT,
		ID_PARALLEL_3_TYPE,
		ID_PARALLEL_3_TYPE_PAINT,
		ID_ANGLE_1_TYPE,
		ID_ANGLE_1_TYPE_PAINT,
		ID_ANGLE_2_TYPE,
		ID_ANGLE_2_TYPE_PAINT,
		ID_COMPLEX_LINE_CANVAS,
		ID_COMPLEX_LINE_1_EPS,
		ID_COMPLEX_LINE_2_EPS,
		ID_LAST
	};
};



#endif //_TUNER_H_